% Pizzeria Lucania

salat('Mista', 5).
salat('Capriciosa', 8).
fleisch('Cotoletta', 11).
fleisch('Filetto ai Ferri', 20).
nudeln('Spaghetti Bolognese', 8).
nudeln('Lasagne', 10).
nudeln('Canelloni', 11).
fisch('Calamari Fritti', 15).
fisch('Sogliola', 18).
dessert('Tiramisu', 4).
dessert('Cassata', 5).

hauptspeise(Speise, Preis):- 
  fleisch(Speise, Preis).
hauptspeise(Speise, Preis):- 
  nudeln(Speise, Preis).
hauptspeise(Speise, Preis):- 
  fisch(Speise, Preis).

hauptgericht(Speise):- 
  hauptspeise(Speise, _).

menue(Salat, Gericht, Dessert):- 
  salat(Salat, _),
  hauptgericht(Gericht),
  dessert(Dessert, _).
                                  
preis(Salat, Gericht, Dessert, Preis):-
  salat(Salat, X1),
  hauptspeise(Gericht, X2),
  dessert(Dessert, X3),
  Preis is X1 + X2 + X3.
  
