% eine Mini-Grammatik

artikel(der).

nomen(hund).
nomen(jaeger).

verb(bellt).
verb(flieht).
verb(schiesst).

nominalphrase(X, Y):-
  artikel(X),
  nomen(Y).

verbalphrase(Z):-
  verb(Z).

satz(X, Y, Z):-
  nominalphrase(X, Y),
  verbalphrase(Z).

frage(X, Y, Z):-
  verb(X),
  nominalphrase(Y, Z).
  